## groupie-tracker-visualizations

### Objectives

You must follow the same [principles](../README.md) as the first subject.

Groupie tracker visualizations consists of manipulating the data coming from the API and displaying it in the most presentable way possible to you. The [_Schneiderman's 8 Golden Rules of Interface Design_](https://www.interaction-design.org/literature/article/shneiderman-s-eight-golden-rules-will-help-you-design-better-interfaces) must be followed:

- Strive for consistency
- Enable frequent users to use shortcuts
- Offer informative feedback
- Design dialogue to yield closure
- Offer simple error handling
- Permit easy reversal of actions
- Support internal locus of control
- Reduce short-term memory load

### Instructions

- Your project must contain **CSS**.
- The code must respect the [**good practices**](../../good-practices/README.md).
- We suggest you to search for the principles of a good website design.

This project will help you learn about:

- The basics of human-computer interface.
- The basics of CSS.
- Linking CSS and HTML.
